import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Ad, AdParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询广告位
 */
export async function pageAd(params: AdParam) {
  const res = await request.get<ApiResult<PageResult<Ad>>>(
    MODULES_API_URL + '/cms/ad/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询广告位列表
 */
export async function listAd(params?: AdParam) {
  const res = await request.get<ApiResult<Ad[]>>(MODULES_API_URL + '/cms/ad', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加广告位
 */
export async function addAd(data: Ad) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改广告位
 */
export async function updateAd(data: Ad) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除广告位
 */
export async function removeAd(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除广告位
 */
export async function removeBatchAd(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改用户状态
 */
export async function updateAdStatus(adId?: number, status?: number) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad/status',
    {
      adId,
      status
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询广告位
 */
export async function getAd(id: number) {
  const res = await request.get<ApiResult<Ad>>(
    MODULES_API_URL + '/cms/ad/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/ad/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
